/*
 *                                   -----
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago               Data di creazione : 30/9/2004
 * Codice   : 
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */

#include	"ad774x.h"

#include	<i2c.h>

#include 	<p18cxxx.h>  
#include 	<delays.h>
#include	<string.h>

unsigned	char	Buffer[10];

void	xInit(void)
{
	OpenI2C(MASTER, SLEW_ON);

	//	I2C Master mode, clock = Fosc/(4 * (SPADD + 1))
	//	
	//	16000000 / ( 4 * (39 + 1)) = 100000 Hz
	//					  --
	//
	//	16000000 / ( 4 * (9 + 1)) = 400000 Hz
	//					  -

	SSPADD				=	9;

}

signed char putBufferI2C( unsigned char *wrptr, unsigned len )
{
 	while ( len-- )                 // transmit data until null character 
  	{
      	if ( putcI2C( *wrptr ) )    // write 1 byte
      	{
        	return ( -3 );             // return with write collision error
      	}
      	IdleI2C();                  // test for idle condition

   		if ( SSPCON2bits.ACKSTAT )  // test received ack bit state
   		{	
       		return ( -2 );             // bus device responded with  NOT ACK
   		}                            // terminate putsI2C1() function

  		wrptr ++;                        // increment pointer
  	}                                // continue data writes until null character
}

unsigned char EEWriteBuffer( unsigned char control, unsigned char address, unsigned char *wrptr, unsigned len)
{
  IdleI2C();                      // ensure module is idle
  StartI2C();                     // initiate START condition

  while ( SSPCON2bits.SEN );      // wait until start condition is over 

  if ( PIR2bits.BCLIF )           // test for bus collision
  {
    return ( -1 );                // return with Bus Collision error 
  }
  else
  {
    if ( WriteI2C( control ) )    // write 1 byte - R/W bit should be 0
    {
      return ( -3 );              // return with write collision error
    }

    IdleI2C();                    // ensure module is idle

    if ( !SSPCON2bits.ACKSTAT )   // test for ACK condition, if received 
    { 
      if ( WriteI2C( address ) )  // write address byte to EEPROM
      {
        return ( -3 );            // return with write collision error
      }

      IdleI2C();                  // ensure module is idle

      if ( !SSPCON2bits.ACKSTAT ) // test for ACK condition, if received
      {
        if ( putBufferI2C ( wrptr, len ) )
        {
          return( -4 );           // bus device responded possible error
        }
      }
      else
      {
        return ( -2 );            // return with Not Ack error
      }
    }
    else
    {
      return ( -2 );              // return with Not Ack error
    }
  }

  IdleI2C();                      // ensure module is idle
  StopI2C();                      // send STOP condition
  while ( SSPCON2bits.PEN );      // wait until stop condition is over 
  if ( PIR2bits.BCLIF )           // test for Bus collision
  {
    return ( -1 );                // return with Bus Collision error 
  }
  return ( 0 );                   // return with no error
}

unsigned int xReset(void)
{
	IdleI2C();                      // ensure module is idle
  	StartI2C();                     // initiate START condition

  	while ( SSPCON2bits.SEN );      // wait until start condition is over 
  	if ( PIR2bits.BCLIF )           // test for bus collision
  	{
    	return ( -1 );                 // return with Bus Collision error 
  	}
  	else                             // start condition successful
  	{
    	if ( WriteI2C( 0x00 ) )    // write byte - R/W bit should be 0
    	{
      		return ( -3 );               // set error for write collision
    	}

    	IdleI2C();                    // ensure module is idle
    	
		if ( !SSPCON2bits.ACKSTAT )   // test for ACK condition received
    	{ 
      		if ( WriteI2C( 0x06 ) )  // write word address for EEPROM
      		{
        		return ( -3 );             // set error for write collision
      		}
    	}
    	else
    	{
      		return ( -2 );               // return with Not Ack error condition   
    	}
  	}

  	IdleI2C();                      // ensure module is idle  
  	StopI2C();                      // send STOP condition
  	while ( SSPCON2bits.PEN );      // wait until stop condition is over 
  	
	if ( PIR2bits.BCLIF )           // test for bus collision
  	{
    	return ( -1 );                // return with Bus Collision error 
  	}
  	return ( 0 );                   // return with no error
}


void xReadMultipleRegisters(x*  p_Buffer)
{ 
	EESequentialRead(xAddress, 0, p_Buffer->R.pby_ReadBuffer, 80);
} 

void xWriteMultipleRegisters(x* p_Buffer) 
{ 
	EEWriteBuffer( xWRITEADDRESS, 0x07, &p_Buffer->W.pby_WriteBuffer[7], xNUMBEROFWRITABLEREGISTERS);
} 

unsigned int xReadSingleRegister(unsigned char pby_Address) 
{
	return	EERandomRead(xWRITEADDRESS, pby_Address);
}

unsigned int xWriteSingleRegister(unsigned char pby_Address, unsigned char	pby_Data) 
{
	return	EEByteWrite(xWRITEADDRESS, pby_Address, pby_Data);
}


